//---------------------------------------------------------------------------


#pragma hdrstop

#include "FractData.h"
#include "stdlib.h"

CFractData::CFractData()
{
  data = NULL;
  x=0;
  y=0;
}

CFractData::~CFractData()
{
  if (data) delete data;
}

bool CFractData::setDimensions(int xx, int yy)
{
  if (x!=xx || y!=yy)
  {
    if (data) delete data;
    data = new CDataItem[xx*yy];
    x=xx;
    y=yy;
  }
  return true;
}

int CFractData::getX()
{
  return x;
}

int CFractData::getY()
{
  return y;
}





//---------------------------------------------------------------------------

#pragma package(smart_init)

int CFractData::BoxDim(int boxSize)
{
  int cnt = 0;
  for (int i=0;i<(x/boxSize);i++)
    for (int j=0;j<(y/boxSize);j++)
    {
      if (ContainsSet(i*boxSize,j*boxSize,boxSize))
        cnt++;
    }
    return cnt;
}

bool CFractData::ContainsSet(int xx, int yy, int d)
{
  int c = random(255);
  bool ok=false;
  for (int i=xx;i<xx+d;i++)
    for (int j=yy;j<yy+d;j++)
    {
      if (data[i+j*x].numiter==0)
      {
        ok=true;
        break;
      }
      //data[i+j*x].numiter = (data[i+j*x].numiter + c)%256;
      if (ok) break;
    }

  for (int i=xx;i<xx+d;i++)
    for (int j=yy;j<yy+d;j++)
    {
      data[i+j*x].numiter = ((int)ok)*255;
    }
  return ok;
}
