//---------------------------------------------------------------------------

#ifndef GrafWndH
#define GrafWndH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "PERFGRAP.h"
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>
//---------------------------------------------------------------------------
class TGrafWindow : public TForm
{
__published:	// IDE-managed Components
  TImage *Img;
  TMainMenu *MainMenu1;
  TMenuItem *File1;
  TMenuItem *Save1;
  TMenuItem *Close1;
  TMenuItem *View1;
  TMenuItem *N111;
  TMenuItem *Color1;
  TMenuItem *ShowValues1;
  TColorDialog *ColorDlg;
  TMenuItem *Plot1;
  TMenuItem *Abs1;
  TMenuItem *Imag1;
  TSavePictureDialog *SaveImg;
  void __fastcall FormResize(TObject *Sender);
  void __fastcall N111Click(TObject *Sender);
  void __fastcall ShowValues1Click(TObject *Sender);
  void __fastcall Color1Click(TObject *Sender);
  void __fastcall Imag1Click(TObject *Sender);
  void __fastcall Abs1Click(TObject *Sender);
  void __fastcall Save1Click(TObject *Sender);
private:	// User declarations
  double *re;
  double *im;
  double *abs;

  double maxx;
  double maxy;
  double minx;
  double miny;
  double minabs;
  double maxabs;
  int border;

  int count;
  void FindBounds(bool constRatio);
  void DrawAxesImg(double stepRe,double stepIm);
  void DrawAxesAbs(int step,double stepAbs);
  void DrawImag();
  void DrawAbs();
  int ReToPos(double re);
  int ImToPos(double im);
  int AbsToPos(double abs);
  int IndexToPos(int i);
  void Kresli();

public:		// User declarations
  __fastcall TGrafWindow(TComponent* Owner);
  void SetBorder(int b);
  void Zobraz(double*RE, double *IM, double* ABS, int COUNT);
};
//---------------------------------------------------------------------------
extern PACKAGE TGrafWindow *GrafWindow;
//---------------------------------------------------------------------------
#endif
