//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainWindow.h"
#include "render.h"
#include "GrafWnd.h"
#include "box.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainWND *MainWND;
TMainWND *JuliaWND;
//---------------------------------------------------------------------------
__fastcall TMainWND::TMainWND(TComponent* Owner)
  : TForm(Owner)
{
  MandelThread = new TMandelThread(false);
  Img->Picture->Bitmap->PixelFormat = pf32bit;
  Img->Picture->Bitmap->Width = Img->Width;
  Img->Picture->Bitmap->Height = Img->Height;
  //MandelThread->Set_pBMP(Img->Picture->Bitmap);

  Bar->Panels->Items[0]->Width = 150;
  Bar->Panels->Items[1]->Width = 150;
  Bar->Panels->Items[2]->Width = 60;
  Bar->Panels->Items[3]->Width = 60;
  Bar->Panels->Items[4]->Width = 100;

  Type = MANDEL4;

  sx=1;
  sy=1;
}
//---------------------------------------------------------------------------

void __fastcall TMainWND::Exit1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainWND::Mandel1Click(TObject *Sender)
{
  Type=MANDEL2;
  Start(MANDEL2);
}
//---------------------------------------------------------------------------
void __fastcall TMainWND::FormResize(TObject *Sender)
{
  Img->Picture->Bitmap->Width = Img->Width;
  Img->Picture->Bitmap->Height = Img->Height;
  Render r;
  r.Standard(&(MandelThread->data),Img->Picture->Bitmap,&sx,&sy);
  Img->Refresh();  
}
//---------------------------------------------------------------------------
void __fastcall TMainWND::TimerTimer(TObject *Sender)
{
  Render r;
  r.Standard(&(MandelThread->data),Img->Picture->Bitmap,&sx,&sy);
  Img->Refresh();
  Bar->Panels->Items[2]->Text =
    FloatToStrF(MandelThread->Get_progress(),ffFixed,3,1)+" %";

    Bar->Panels->Items[3]->Text =
    AnsiString(MandelThread->GetLastCalcTime()/1000)+"."+
    AnsiString(MandelThread->GetLastCalcTime()%1000)+" s";

  if (!MandelThread->In_Progress())
  {
    Timer->Enabled = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainWND::Mandel31Click(TObject *Sender)
{
  Type=MANDEL3;
  Start(MANDEL3);
}
//---------------------------------------------------------------------------


void __fastcall TMainWND::Start(int i)
{
  MandelThread->Start(i,Img->Width,Img->Height);
  Timer->Enabled = true;
}
void __fastcall TMainWND::ImgMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if (Button==mbLeft)
  {
    sel->Visible = true;
    sel->Left = X;
    sel->Top = Y;
    sel->Width =1;
    sel->Height =1;
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainWND::ImgMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
  if ((Button == mbLeft) && (sel->Visible))
  {
    sel->Visible = false;
    if (sel->Width>=5 && sel->Height>=5)
    {
      MandelThread->ZoomRect(int(sel->Left*sx),int(sel->Top*sy),int(X*sx),int(Y*sy));
      Start(Type);
    }
  }
  if ((Button == mbLeft) && (Shift.Contains(ssCtrl)))
  {
    MandelThread->IterSeq(Type,int(X*sx),int(Y*sy),20);
    double *re = MandelThread->Get_pRe();
    double *im = MandelThread->Get_pIm();
    Img->Canvas->Pen->Color = clWhite;
    int x = MandelThread->reToX(re[0]);
    int y = MandelThread->imToY(im[0]);

    Img->Canvas->MoveTo(int(x*sx),int(y*sx));
    for (int i=0;i<MandelThread->Get_iter();i++)
    {
      x = MandelThread->reToX(re[i]);
      y = MandelThread->imToY(im[i]);
      Img->Canvas->LineTo(int(x*sx),int(y*sx));
    }
    GrafWindow->Show();
    GrafWindow->Zobraz(MandelThread->Get_pRe(),
                       MandelThread->Get_pIm(),
                       MandelThread->Get_pAbs(),
                       MandelThread->Get_iter());
  }
  if (Button == mbRight)
  {
    JuliaWND->MandelThread->setCr(MandelThread->XtoRe(int(X*sx)));
    JuliaWND->MandelThread->setCi(MandelThread->YtoIm(int(Y*sy)));
    JuliaWND->Caption = AnsiString("Julia ")+
                        MandelThread->XtoRe(int(X*sx))+" + i*"+
                        MandelThread->YtoIm(int(Y*sy));
    JuliaWND->setType(Type%10+10);
    if (!JuliaWND->Visible)
    {
      JuliaWND->Top = Top+40;
      JuliaWND->Left = Left+40;
      JuliaWND->Show();
    }
    else JuliaWND->Start(Type%10+10);
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainWND::ImgMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
  if (sel->Visible)
  {
    sel->Width = X - sel->Left;
    sel->Height = Y - sel->Top;
  }
  Bar->Panels->Items[0]->Text = AnsiString("Re: ")+MandelThread->XtoRe(int(X*sx));
  Bar->Panels->Items[1]->Text = AnsiString("Im: ")+MandelThread->YtoIm(int(Y*sy));
}
//---------------------------------------------------------------------------



void __fastcall TMainWND::Reset1Click(TObject *Sender)
{
  MandelThread->Reset();
  Start(Type);  
}
//---------------------------------------------------------------------------


void __fastcall TMainWND::N2x1Click(TObject *Sender)
{
  MandelThread->ZoomPct(2);
  Start(Type);
}
//---------------------------------------------------------------------------

void __fastcall TMainWND::N3x1Click(TObject *Sender)
{
  MandelThread->ZoomPct(3);
  Start(Type);
}
//---------------------------------------------------------------------------

void __fastcall TMainWND::N5x1Click(TObject *Sender)
{
  MandelThread->ZoomPct(5);
  Start(Type);
}
//---------------------------------------------------------------------------

void __fastcall TMainWND::N10x1Click(TObject *Sender)
{
  MandelThread->ZoomPct(10);
  Start(Type);
}
//---------------------------------------------------------------------------

void __fastcall TMainWND::N2x2Click(TObject *Sender)
{
  MandelThread->ZoomPct(0.5);
  Start(Type);
}
//---------------------------------------------------------------------------

void __fastcall TMainWND::N3x2Click(TObject *Sender)
{
  MandelThread->ZoomPct(0.3333);
  Start(Type);
}
//---------------------------------------------------------------------------

void __fastcall TMainWND::N51Click(TObject *Sender)
{
  MandelThread->ZoomPct(0.2);
  Start(Type);
}
//---------------------------------------------------------------------------

void __fastcall TMainWND::N10x2Click(TObject *Sender)
{
  MandelThread->ZoomPct(0.1);
  Start(Type);
}
//---------------------------------------------------------------------------

void __fastcall TMainWND::FormShow(TObject *Sender)
{
  //Type=MANDEL2;
  Start(Type);
}
//---------------------------------------------------------------------------

void __fastcall TMainWND::Save1Click(TObject *Sender)
{
  if (SavePic->Execute())
    Img->Picture->SaveToFile(SavePic->FileName);
}
//---------------------------------------------------------------------------


void TMainWND::setType(int t)
{
  Type = t;
}
void __fastcall TMainWND::Julia21Click(TObject *Sender)
{
  Type=JULIA2;
  Start(Type);
}
//---------------------------------------------------------------------------

void __fastcall TMainWND::Julia31Click(TObject *Sender)
{
  Type=JULIA3;
  Start(Type);
}
//---------------------------------------------------------------------------

void __fastcall TMainWND::Mandel41Click(TObject *Sender)
{
  Type=MANDEL4;
  Start(Type);
}
//---------------------------------------------------------------------------

void __fastcall TMainWND::Julia41Click(TObject *Sender)
{
  Type=JULIA4;
  Start(Type);
}
//---------------------------------------------------------------------------



void __fastcall TMainWND::Count1Click(TObject *Sender)
{
  box_dim->Show(this);
}
//---------------------------------------------------------------------------

void __fastcall TMainWND::Redraw1Click(TObject *Sender)
{
  Render r;
  r.Standard(&(MandelThread->data),Img->Picture->Bitmap,&sx,&sy);
  Img->Refresh();  
}
//---------------------------------------------------------------------------

