//---------------------------------------------------------------------------

#ifndef MandelThreadH
#define MandelThreadH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <graphics.hpp>
#include "Registry.h"
#include "FractData.h"
//---------------------------------------------------------------------------
#define MANDEL2 2
#define MANDEL3 3
#define MANDEL4 4
#define MANDEL5 5
#define MANDEL6 6
#define MANDEL7 7
#define JULIA2  12
#define JULIA3  13
#define JULIA4  14
#define JULIA5  15
#define JULIA6  16
#define JULIA7  17
#define STOP    0

class TMandelThread : public TThread
{
private:
  double xmin,xmax,ymin,ymax;
  double cr,ci;   //real and imag. part of const for Julia sets
  int iter;
  //Graphics::TBitmap * pBMP;
  unsigned long int poc_vyp;
  bool volatile in_progress;
  double progress;
  bool start;       //if true, algorith starts
  CRegistry *msg_queue;
  double *im;
  double *re;
  double *abs;
  unsigned start_time;
  unsigned time;

  bool Mandel2();
  bool Mandel3();
  bool Mandel4();
  bool Julia2();
  bool Julia3();
  bool Julia4();

protected:
  void __fastcall Execute();

public:
  CFractData data;
  __fastcall TMandelThread(bool CreateSuspended);
  __fastcall ~TMandelThread();
  void Reset();
  void Start(int exp, int x, int y);
  //void Set_pBMP(Graphics::TBitmap *p);
  //Graphics::TBitmap * Get_pBMP();
  void Set_xmin(double x);
  void Set_xmax(double x);
  void Set_ymin(double x);
  void Set_ymax(double x);
  double Get_xmin();
  double Get_xmax();
  double Get_ymin();
  double Get_ymax();
  unsigned int Get_iter();
  void Set_iter(unsigned int i);
  double Get_progress();
  bool __fastcall In_Progress();
  void IterSeq(int type,int x, int y, double r);
  double * __fastcall Get_pRe();
  double * __fastcall Get_pIm();
  double * __fastcall Get_pAbs();
  void ZoomRect(int x1, int y1,int x2, int y2);
  unsigned GetLastCalcTime();
  void ZoomPct(double zoom);
  int Get_PocVyp(void);
  double XtoRe(int x);
  double YtoIm(int y);
  void setCr(double r);
  void setCi(double i);
  int reToX(double re);
  int imToY(double im);
  //void Set_Dimensions(int x, int y);
};
//---------------------------------------------------------------------------
#endif
